! module C_FUNC_SUB
!     contains 

!     INTEGER function get_char_len(name) BIND(C)
!         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR
!         IMPLICIT NONE
!         CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
!     end function get_char_len
    
! end module C_FUNC_SUB

module PARSER_C_FUNC

    INTERFACE
        SUBROUTINE run(filename) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),  intent(in)  :: filename(*)
        END SUBROUTINE run

        SUBROUTINE get_int(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_INT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),  intent(in)    :: name(*)
            INTEGER   (KIND=C_INT),   intent(out)   :: value
        END SUBROUTINE get_int

        SUBROUTINE get_float(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_FLOAT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            REAL      (KIND=C_FLOAT),   intent(out)   :: value
        END SUBROUTINE get_float

        SUBROUTINE get_double(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_DOUBLE
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            REAL      (KIND=C_DOUBLE),  intent(out)   :: value
        END SUBROUTINE get_double

        ! TODO:
        SUBROUTINE get_char_len(name, len) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_INT
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            INTEGER   (KIND=C_INT),     intent(out)   :: len
        END SUBROUTINE get_char_len

        SUBROUTINE get_charc(name, value) BIND(C)
            USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR),    intent(in)    :: name(*)
            CHARACTER (KIND=C_CHAR),    intent(out)   :: value(*)
        END SUBROUTINE get_charc

    END INTERFACE  
end module PARSER_C_FUNC

! TODO:

SUBROUTINE get_char_lenf(name, len) 
    USE PARSER_C_FUNC

    IMPLICIT NONE
    CHARACTER, intent(in) :: name(*)
    INTEGER, intent(out)  :: len

    call get_char_len(name, len)
END SUBROUTINE get_char_lenf

SUBROUTINE get_charf(name, char_value) 
    USE PARSER_C_FUNC

    IMPLICIT NONE
    CHARACTER, allocatable, intent(OUT) :: char_value(:)

    CHARACTER, intent(in) :: name(*)
    INTEGER :: len

    call get_char_lenf(name, len)
    
    write(*, *) 'len = ', len

    ! IF(ALLOCATED(char_value)) DEALLOCATE(char_value)
    ! allocate(char_value(4))
END SUBROUTINE get_charf